searchData={"content_type":"text/markdown","items":[{"doc":"Heyya is here to help with you testing","ref":"Heyya.html","title":"Heyya","type":"module"},{"doc":"`Heyya.LiveTest` module provides helper methods that make it easier to write a\nmore linear live view test. It takes care of the fact that there's\nconnection state, view state, and last html state.\n\nThese ideas origionally came from: https://www.reddit.com/r/elixir/comments/ydyt2m/better_liveview_tests/\n\nThis implementation doesn't hide follow (in large part because\nof the ergonomics of follow_redirect being a macro)","ref":"Heyya.LiveTest.html","title":"Heyya.LiveTest","type":"module"},{"doc":"```\ndefmodule MyPhoenixWeb.ListLiveTest do\n  use Heyya.LiveTest\n  use MyPhoenixWeb.ConnCase\n\n  test \"widget list with new button\", %{conn: conn} do\n    start(conn, ~p|/widgets|)\n    |> assert_html(\"Widgets List\")\n    |> click(\"a\", \"New Widgets\")\n    |> follow(~p|/widgets/new|)\n  end\nend\n```","ref":"Heyya.LiveTest.html#module-example","title":"Example - Heyya.LiveTest","type":"module"},{"doc":"","ref":"Heyya.LiveTest.html#assert_element/3","title":"Heyya.LiveTest.assert_element/3","type":"function"},{"doc":"Asserts that the html in the LiveTestSession matches the\nprovided expected html.\n\nReturns the LiveTestSession.","ref":"Heyya.LiveTest.html#assert_html/2","title":"Heyya.LiveTest.assert_html/2","type":"function"},{"doc":"","ref":"Heyya.LiveTest.html#assert_page_title/2","title":"Heyya.LiveTest.assert_page_title/2","type":"function"},{"doc":"This method will use LiveViewTest.render_async to ensure that all\noutstanding async operations are completed.  By default this\nwill wait the ExUnit default timeout.","ref":"Heyya.LiveTest.html#await_async/2","title":"Heyya.LiveTest.await_async/2","type":"function"},{"doc":"This method clicks on an element that's selected via selector then renders\nthe result. Finally returning a new LiveTestSession with updated rendered html\n\nThis will also assert that there is an element that's specified by the selector\n\nThis doesn't follow navigations or redirect.\n\nreturns: `%Heyya.LiveTestSession{}`","ref":"Heyya.LiveTest.html#click/3","title":"Heyya.LiveTest.click/3","type":"function"},{"doc":"","ref":"Heyya.LiveTest.html#focus/2","title":"Heyya.LiveTest.focus/2","type":"function"},{"doc":"Macro that creates code to follow a redirect. This takes\nin a LiveTestSession and will assert that a redirect exists.","ref":"Heyya.LiveTest.html#follow/2","title":"Heyya.LiveTest.follow/2","type":"macro"},{"doc":"Sets the form specified by the selector to a new value.\n\nThis doesn't submit the form\n\nreturns: `%Heyya.LiveTestSession{}`","ref":"Heyya.LiveTest.html#form/3","title":"Heyya.LiveTest.form/3","type":"function"},{"doc":"","ref":"Heyya.LiveTest.html#refute_element/3","title":"Heyya.LiveTest.refute_element/3","type":"function"},{"doc":"Refute that the html in the LiveTestSession matches the provided html string.\n\nReturns the LiveTestSession.","ref":"Heyya.LiveTest.html#refute_html/2","title":"Heyya.LiveTest.refute_html/2","type":"function"},{"doc":"","ref":"Heyya.LiveTest.html#refute_page_title/2","title":"Heyya.LiveTest.refute_page_title/2","type":"function"},{"doc":"Macro that creates code to start a new LiveTestSession. This takes in a plug\nconnection (Usually from your ConnTest)","ref":"Heyya.LiveTest.html#start/2","title":"Heyya.LiveTest.start/2","type":"macro"},{"doc":"Submits the form and renders the result of submitting.\n\nThis doesn't follow any redirects.\n\nreturns: `%Heyya.LiveTestSession{}`","ref":"Heyya.LiveTest.html#submit_form/3","title":"Heyya.LiveTest.submit_form/3","type":"function"},{"doc":"This module is a struct to hold the state of a session of live view testing.\n\n\nIt wraps up Plug connection, the current view, and the latest rendered html","ref":"Heyya.LiveTestSession.html","title":"Heyya.LiveTestSession","type":"module"},{"doc":"","ref":"Heyya.LiveTestSession.html#t:t/0","title":"Heyya.LiveTestSession.t/0","type":"type"},{"doc":"`Heyya.SnapshotTest` allows for fast snapshot\ntesting of Phoenix components. Snapshot testing\ncomponents is a fast and easy way to ensure that\nthey work and produce what they expected to\nproduce without having to hand write\nassertions.","ref":"Heyya.SnapshotTest.html","title":"Heyya.SnapshotTest","type":"module"},{"doc":"Wire up the module to prepare for snapshot testing.","ref":"Heyya.SnapshotTest.html#__using__/1","title":"Heyya.SnapshotTest.__using__/1","type":"macro"},{"doc":"","ref":"Heyya.SnapshotTest.html#compare_html/2","title":"Heyya.SnapshotTest.compare_html/2","type":"function"},{"doc":"A named component snapshot test","ref":"Heyya.SnapshotTest.html#component_snapshot_test/2","title":"Heyya.SnapshotTest.component_snapshot_test/2","type":"macro"},{"doc":"A named component snapshot test, where context is passed through.","ref":"Heyya.SnapshotTest.html#component_snapshot_test/3","title":"Heyya.SnapshotTest.component_snapshot_test/3","type":"macro"},{"doc":"Gets the directory to store snapshot files for the test.","ref":"Heyya.SnapshotTest.html#directory/1","title":"Heyya.SnapshotTest.directory/1","type":"function"},{"doc":"- env: The macro environment which contains metadata about the test file.","ref":"Heyya.SnapshotTest.html#directory/1-parameters","title":"Parameters - Heyya.SnapshotTest.directory/1","type":"function"},{"doc":"The directory path as a binary where snapshots should be stored.","ref":"Heyya.SnapshotTest.html#directory/1-returns","title":"Returns - Heyya.SnapshotTest.directory/1","type":"function"},{"doc":"","ref":"Heyya.SnapshotTest.html#filename/1","title":"Heyya.SnapshotTest.filename/1","type":"function"},{"doc":"Gets the stored snapshot for the given macro environment.\n\nThis looks up the snapshot file path and name based on the environment,\nreads the file contents, and returns the snapshot.\n\nIf there is no snapshot file yet, returns an empty binary.","ref":"Heyya.SnapshotTest.html#get_snapshot/1","title":"Heyya.SnapshotTest.get_snapshot/1","type":"function"},{"doc":"- env: The macro environment which contains metadata about the test module and function.","ref":"Heyya.SnapshotTest.html#get_snapshot/1-parameters","title":"Parameters - Heyya.SnapshotTest.get_snapshot/1","type":"function"},{"doc":"The stored snapshot as a binary, or empty binary if no snapshot exists.","ref":"Heyya.SnapshotTest.html#get_snapshot/1-returns","title":"Returns - Heyya.SnapshotTest.get_snapshot/1","type":"function"},{"doc":"","ref":"Heyya.SnapshotTest.html#inner_test/1","title":"Heyya.SnapshotTest.inner_test/1","type":"macro"},{"doc":"","ref":"Heyya.SnapshotTest.html#override!/2","title":"Heyya.SnapshotTest.override!/2","type":"function"},{"doc":"","ref":"Heyya.SnapshotTest.html#override?/0","title":"Heyya.SnapshotTest.override?/0","type":"function"},{"doc":"# Heyya\n\n`Heyya` is a utility to help with testing your [Phoenix](https://www.phoenixframework.org/) components and live view.","ref":"readme.html","title":"Heyya","type":"extras"},{"doc":"Getting Started\n\nTo use Heyya in your Phoenix project, add it to your list of dependencies in mix.exs:\n\n```elixir\ndef deps do\n  [\n    {:heyya, \"~> 0.5.0\"}\n  ]\nend\n```\n\nThen, run `mix deps.get` to install Heyya and its dependencies.","ref":"readme.html#getting-started","title":"Getting Started - Heyya","type":"extras"},{"doc":"```\nuse Heyya.SnapshotTest\n\ncomponent_snapshot_test \"Super Simple H1 Test\" do\n  assigns = %{}\n\n  ~H\"\"\"\n   Testing \n  \"\"\"\nend\n```\n\nTo run the snapshot tests, run `mix test` as usual. This will compare the snapshots to the current rendered output of the components and fail the tests if the snapshots do not match.\n\nIf you need to update the snapshots for any reason, you can run `HEYYA_OVERRIDE=true mix test` to reset the snapshot values to the current rendered output of the components.\n\nCredit:\n\nThe initial snapshot code used [Snapshy](https://hex.pm/packages/snapshy). We have since moved on to inspect the html rather than using snapshy. Thank you to them for the initial implementation.","ref":"readme.html#example-snapshot-usage","title":"Example Snapshot Usage - Heyya","type":"extras"},{"doc":"```\nuse Heyya.LiveTest\nuse MyPhoenixWeb.ConnCase\ntest \"widget list with new button\", %{conn: conn} do\n  start(conn, ~p|/widgets|)\n  |> assert_html(\"Widgets List\")\n  |> click(\"a\", \"New Widgets\")\n  |> follow(~p|/widgets/new|)\nend\n```","ref":"readme.html#example-live-view-test","title":"Example Live View Test - Heyya","type":"extras"},{"doc":"We welcome contributions to Heyya! Please see the CONTRIBUTING.md file for guidelines on how to contribute.","ref":"readme.html#contributing","title":"Contributing - Heyya","type":"extras"},{"doc":"Heyya is released under the MIT License.","ref":"readme.html#license","title":"License - Heyya","type":"extras"}]}